<?php

namespace App\DataObjects;

use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Spatie\DataTransferObject\DataTransferObject;

class PaymentDataObject extends DataTransferObject
{
    /** @var int $price */
    public $price;

    /** @var string $price */
    public $currency;

    /** @var string $description */
    public $description;

    /** @var string $status */
    public $status;

    /** @var string $timestamp */
    public $timestamp;

    /** @var array $data */
    public $data;

    public static function fromRequest(Request $request): self
    {
        $transaction = $request->get('transaction');

        return new self([
            'price' => (int) $transaction['amount'],
            'currency' => $transaction['currency'],
            'description' => $transaction['description'],
            'status' => $transaction['status'],
            'timestamp' => Carbon::now()->toString(),
            'data' => $request->all(),
        ]);
    }
}
