<?php

namespace App\Http\Controllers;

use App\DataObjects\PaymentDataObject;
use App\Mail\PaymentReceived;
use Illuminate\Http\Request;
use Illuminate\Mail\MailManager;

final class ReceivePayment extends Controller
{
    public function __invoke(Request $request, MailManager $mail)
    {
        $this->validate($request, [
            'transaction.amount' => 'required',
            'transaction.currency' => 'required',
            'transaction.description' => 'required',
            'transaction.status' => 'required',
        ]);

        $payment = PaymentDataObject::fromRequest($request);

        $mail->to(config('mail.to.address'))->send(new PaymentReceived($payment));

        return response(null, 204);
    }
}
