<?php

namespace App\Mail;

use App\DataObjects\PaymentDataObject;
use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class PaymentReceived extends Mailable
{
    use Queueable, SerializesModels;

    /**
     * @var PaymentDataObject
     */
    private $payment;

    public function __construct(PaymentDataObject $payment)
    {
        $this->payment = $payment;
    }

    public function build()
    {
        return $this->markdown('received', [
            'payment' => $this->payment,
        ]);
    }
}
